// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "uniformWorldConstants.h"
#include "uniformShaderConstants.h"
#include "fragmentVersionSimple.h"
#include "uniformPerFrameConstants.h"
#include "lib/horizon.h"

in highp vec3 pos;
in highp vec4 dpos;

void main(){

vec3 p = pos/(pos.y-0.14);
vec3 rd = vec3(p.x, 0, p.z);
vec4 fc = FOG_COLOR;

function m;
    m.nightfunc = pow(max(min(1.0-fc.r * 1.5, 1.0), 0.0), 1.2);
    m.sunfunc = pow(max(min(1.0-fc.b * 1.2, 1.0), 0.0), 0.5);
    m.rainfunc = (1.0-pow(FOG_CONTROL.y,5.0));
float far = length(rd.xz);

vec3 cc = mix(vec3(1.0, 0.95, 1.0), vec3(1.0, 0.8, 0.6), m.sunfunc);
       cc = mix(cc, vec3(0.2, 0.4, 0.8)*0.4, m.nightfunc);
       cc = mix(cc, fc.rgb, m.rainfunc);


vec4 cloud = render_clouds(p*12.0, p*0.4, pos.y, m);
//cloud.rgb = cirrus(rd.xz * 2.0, m, fc.rgb, cloud.rgb) * (1.0-cloud.a);
cloud.rgb = mix(cloud.rgb, cc*1.1, far*0.08);

gl_FragColor = vec4(cloud.rgb * cc, cloud.a);

//gl_FragColor = vec4(0);

}
