#include "lib/structure.h"
#include "lib/colorCorrection.h"

void entity_shader(inout vec4 diffuse, in function m, in Color n)
{
    float uvx = L* TILE_LIGHT_COLOR.r;
    float uvy = TILE_LIGHT_COLOR.r;
    float shadow = 1.0-min(max((uvy-0.90)*100.0,0.0),1.0);
   
    highp vec3 np = normalize(cross(dFdx(cpos.zyx),dFdy(cpos.zyx)));
    float bias_torch = mix(1.0-uvx, 1.0-uvx,
smoothstep(0.0,0.75,uvy)*(1.0-m.nightfunc));

    float sp = max(max(0.0,-np.x),max(0.0,np.x));

    vec3 col = mix(n.nooncolor, n.suncolor, m.sunfunc);
    col = mix(col, n.nightcolor, m.nightfunc);
	 col = mix(col, n.raincolor, m.rainfunc);
    shadow = mix(shadow, 1.0, sp);

    diffuse.rgb = mix(diffuse.rgb, 
diffuse.rgb*vec3(0.3), shadow*bias_torch*(1.0-m.rainfunc));

   	float grad = 0.2;
    diffuse.r = (diffuse.r)*(grad + 1.2) + 
(diffuse.g + diffuse.b)*(-grad);
    diffuse.g = (diffuse.g)*(grad + 1.2) + 
(diffuse.r + diffuse.b)*(-grad);
    diffuse.b = (diffuse.b)*(grad + 1.0) + 
(diffuse.r + diffuse.g)*(-grad);

    diffuse.rgb = mix(diffuse.rgb, vec3(dot(diffuse.rgb, vec3(0.5))), 0.1); 
    diffuse.rgb *= col;
    diffuse.rgb = acesFilm(diffuse.rgb);
    highp float far = length(wpos)/RENDER_DISTANCE*1.2;
    diffuse.rgb = mix(diffuse.rgb, vec3(0.7, 0.9, 1.0)*n.fc.rgb*0.9, far*0.5);

}
