#include "lib/horizon.h"

float getWave(highp vec3 pos)
{     
    highp float move = TIME;
    pos.z += move * 0.4;

    float w = sin(noise(vec2(pos.x*0.2 + pos.z *0.2 + pos.y*0.3 + pos.x*0.2, pos.z*0.3 + pos.x*0.2 + pos.z*0.4)));

    float f = cos(noise(vec2(pos.z + pos.y, pos.x + pos.z)));
    float dist = sin(move * 2.5 + pos.x + pos.z)*sin(move * 2.0 + pos.x);

return mix(w, f, dist);
}

float getWater(highp vec3 pos, highp vec3 dpos, float ws)
{
    float a = getWave(pos);
    float b = getWave(pos-0.03);
    float XY = a-b;

    vec3 N = vec3(XY, -XY, 1.0);

    dpos = normalize(dpos);
    vec3 result = N*0.6 + 0.0*N*sin(dpos)/max(0.0, length(dpos.xyz*0.5));

return dot(sin(result), vec3(-0.5, 1.0, ws));
}

vec4 water(function m, Color n)
{
    float water_w = getWater(3.0*position.zyx, worldpos, 1.0);
    vec3 cc = mix(vec3(1.0, 1.0, 1.0), vec3(1.0, 0.7, 0.4), m.sunfunc);
    cc = mix(cc, vec3(0.2,0.4,0.8)*1.1, m.nightfunc);
    cc = mix(cc, n.fc.rgb, m.rainfunc);

     float fr = fbm(worldpos.xz*0.08* pow(water_w*2.7, 4.0))*mix(0.5, 0.08, m.nightfunc);

    vec4 water_col = vec4(vec3(0.1)*n.fc.rgb, 0.1);
    vec4 skyr = vec4(skyc(m, n), 0.15) * 0.8;

    vec4 res = max(water_col, pow(water_w,1.0)*clamp(m.lp+0.5, 0.0, 0.8));
    res += mix(skyr, fr*vec4(cc,1.0), water_w*0.7);
    res.a += pow(m.lp, 10.0);

return res;
}